;(function($) {

    'use strict';

    $.fn.smoothScroll = function(options) {

        var defaluts = {
            $scroller: $('html, body'),
            duration: 1000,
            easing: 'swing',
            cancelable: true,
            cancelEvent: 'click.ss:cancel scroll.ss:cancel mousedown.ss:cancel wheel.ss:cancel DOMMouseScroll.ss:cancel mousewheel.ss:cancel keyup.ss:cancel touchstart.ss:cancel',
            onCancel: function() {},
            afterScroll: function() {}
        };

        var _ = $.extend({}, defaluts, options);
        var $window = $(window);
        var $document = $(document);
        var $body = $('body');

        return this.each(function() {

            $(this).off('click.ss:start').on('click.ss:start', function() {

                var href = $(this).attr('href');
                var $target = $(href);

                if ( !href || !$target[0] ) {
                    return false;
                }



                var targetTop = $target.offset().top;

                if (($document.height() - targetTop) < $window.height()) {
                    targetTop = $document.height() - $window.height();
                }



                if (!_.cancelable) {
                    _.$scroller.animate({ scrollTop: targetTop }, _.duration, _.easing).promise().then(_.afterScroll);
                    return false;
                }



                var deferred = $.Deferred();

                deferred.then(function() {
                    $body.trigger('ss:complete');
                });

                $body.on(_.cancelEvent, function(event) {
                    _.$scroller.stop(true, false);
                    $body.off(_.cancelEvent).off('ss:complete');
                    _.onCancel();
                });

                $body.on('ss:complete', function(event) {
                    $body.off(_.cancelEvent).off('ss:complete');
                    _.afterScroll();
                });

                _.$scroller.animate({ scrollTop: targetTop }, _.duration, _.easing, function() { deferred.resolve(); });

                return false;

            });

        });

    };

})(jQuery);